/*
 *  $Id$
 *
 *  test2.c - UDP Packet assembly tester
 *
 *  route|daemon9 <route@infonexus.com>
 *
 *  $Log$
 */

#include "../../include/libnet.h"
#include <string.h>

#define IP1 "10.0.0.1"
#define IP2 "10.0.0.2"

int
main(int argc, char **argv)
{
    int sock, c;
    u_char *buf;

    printf("Test 2: UDP packet building/writing test\n");

    buf = malloc(UDP_H + IP_H);
    if (!buf)
    {
        perror("No memory for packet header");
        exit(1);
    }

    bzero(buf, UDP_H + IP_H);

    sock = open_raw_sock(IPPROTO_RAW);
    if (sock == -1)
    {
        perror("No socket");
        exit(1);
    }
    
    build_ip(UDP_H,
            242,
            0,
            64,
            IPPROTO_UDP,
            name_resolve(IP1, 1),
            name_resolve(IP2 ,1),
            NULL,
            buf);

    build_udp(0, 1025, 22, NULL, buf + IP_H);

    do_checksum(buf, IPPROTO_UDP, UDP_H);

    c = write_ip(sock, buf, UDP_H + IP_H);
    if (c < UDP_H + IP_H)
    {
        fprintf(stderr, "write_ip\n");
    }
    printf("Completed, wrote %d bytes\n", c);

    free(buf);
    return (0);
}

